#!/usr/local/bin/ruby -Ks

# }CXC[pm ver.2.0
#  textreader.rb: eLXgt@Cǂݍ
# Copyright 2007 again@T
#  http://nijzero.dw.land.to/

require 'jcode'
require 'sourcedata'

class TextParser
  include SourceData
  
  def initialize(filename)
    @cell = []
    @rest = 0
    begin
      if !File.exist?(filename)
        raise "t@C܂"
      end
      linecount = 0
      File.foreach(filename) do |line|
        line.strip!
        next if line.length == 0
        if linecount == 0
          @rest = line.to_i
          linecount += 1
          next
        end
        line.gsub!(/ /, "")
        cellline = line.each_char.collect do |char|
          case char
          when "O","0" then 0
          when "P","1" then 1
          when "Q","2" then 2
          when "R","3" then 3
          when "S","4" then 4
          when "T","5" then 5
          when "U","6" then 6
          when "V","7" then 7
          when "W","8" then 8
          when "","f" then "f"
          else               "u"
          end
        end
        @cell.push(cellline)
      end
    rescue => evar
      raise evar
    end
    colmin = @cell.collect{|row| row.length}.min
    @cell.each do |row|
      row = row[0,colmin]
    end
  end
end